
// Hairdresser Cams
// Widget version 1.2

	var changeIndex = 1;
        var version   = 1.0; 
        var index     = -1;
        var sinceUpdate = 0;
        var webProxy  = "";

        var cameras = new Array();
        
        cameras['All Cameras']     = new Array();

        cameras['All Cameras'][0]  = '"http://www.carlislebarber.com/images/webcam.jpg"|Live from Kirkpatrick`s Hair Salon, Carlisle, Pennsylvania, USA'
        cameras['All Cameras'][1]  = '"http://www.tobysbarbershop.com/cam512.jpg"|Live from Tobys Barber Shop, Lexington Park, Maryland, USA' 
        cameras['All Cameras'][2]  = '"http://wsx.net/electrichair/WebCam/capture2.jpg"|Live from The Electric Hair Company, Newark, Ohio, USA'     
	cameras['All Cameras'][3]  = '"http://www.salon-net.org/realtime100.jpg"|Live from the Nakagawa Barber Shop, Japan'
        cameras['All Cameras'][4]  = '"http://www.cutline-frankfurt.de/cutline-C.jpg"|Live from Cutline, Frankfurt, Germany'
        cameras['All Cameras'][5]  = '"http://www.cutline-frankfurt.de/cutline-A.jpg"|Live from Cutline, Frankfurt, Germany'
        cameras['All Cameras'][6]  = '"http://www.hairfrick.de/webcam/cut.jpg"|Live from Hairfrick, Hamburg, Germany'
	cameras['All Cameras'][7]  = '"http://www.friseursalonhermann.de/webcam32.jpg"|Live from Salon Hermann, Oberhausen, Germany'
        cameras['All Cameras'][8]  = '"http://www.hauptsache-die-haare-liegen.de/cam/cam.jpg"|Live from Salon Young People, Wittmund, Germany'
        cameras['All Cameras'][9]  = '"http://www.hair-concept.de/cams/webcam1/svc_ts.jpg"|Live from Hair Concept in Cologne-Riehl, Germany'
        cameras['All Cameras'][10]  = '"http://www.hair-concept.de/cams/webcam5/svc_ts.jpg"|Live from Hair Concept in Puhlheim, Germany'
        cameras['All Cameras'][12]  = '"http://www.frisurenwerkstatt.de/bilder/webcam/cam1.jpg"|Live from Frisurenwerkstatt Salon Schnatz, Biblis, Germany'
        cameras['All Cameras'][13]  = '"http://www.haircutcompany.de/webcam/pw.jpg"|Live from Haircutcompany, Erlangen, Germany'
        cameras['All Cameras'][14]  = '"http://www.hairtoday.nl/webcam/webcamht1.jpg"|Live from Hair Today in Zwolle, Holland'
        cameras['All Cameras'][15]  = '"http://www.nomorehangovers.co.uk/lisburnroad/cam2.jpg"|Live from Jason Shankey in Belfast, Ireland'
        cameras['All Cameras'][16]  = '"http://www.barbercam.co.uk/cams/2/feed.jpg"|Live from Refresh in St. Ives, UK'
        cameras['All Cameras'][17]  = '"http://www.barbercam.co.uk/cams/4/feed.jpg"|Live from Brooks Barbers in Cambridge, UK'



        function prevIndex()
        {
            index = index - 1;

            if (index &lt; 0)
                index = cameras[preferences.location.value].length - 1;

			updateCamera();
        }

        function nextIndex()
        {
            index = index + 1;

            if (index &gt; cameras[preferences.location.value].length - 1)
	        index = 0;

			updateCamera();
        }

		function pauseIndex()
		{
			changeIndex = (changeIndex == 0) ? 1 : 0;

			if (changeIndex == 1)
				pauseTitle.data = "";
			else
				pauseTitle.data = "PAUSED";

			pauseShadow.data = pauseTitle.data;
        }

        function updateCamera() 
        {
            var cacheFile;
            print('Fetching cameras for '+preferences.location.value);
            
            imgInfo = cameras[preferences.location.value][index].split(/\|/);
            
            cacheFile = "Cache/cache.jpg";
            
            if (preferences.webProxy.value != "")
                webProxy = "-x " + preferences.webProxy.value;

            var getImage = "curl " + webProxy + " --silent " + imgInfo[0]
                    + " --max-time 300 -w \"%{http_code}\\n\" --output " 
                    + cacheFile;

            print("Show  : " + index);
            print("Run   : " + getImage);
            print("Cache : " + cacheFile);

            var result = runCommand(getImage);
            print("Returned : " + result);

            displayFile = cacheFile;

            // Change text to reflect the changed image
            imageTitle.data = imgInfo[1];
            imageTitleShadow.data = imgInfo[1];
            
            // Fade between the images
            fadeImage.vOffset = 26;
            fadeImage.hOffset = 0;
            fadeImage.opacity = 0;
            fadeImage.src = cacheFile;
            fadeImage.reload();
            fadeImage.fade(fadeImage.opacity, 255, 1);
            cameraImage.fade(cameraImage.opacity, 0, 1);
            
            // Reset cameraImage to be the 'main' image holder
            cameraImage.vOffset = 26;
            cameraImage.hOffset = 0;
            cameraImage.src = fadeImage.src;
            cameraImage.reload();
            cameraImage.opacity = 255;
            
            sinceUpdate = 0;
        }
        
        function updateSize() 
        {
            suppressUpdates();
            
            print("Value: "+preferences.imageSize.value);
            if (preferences.imageSize.value == "256x192")
            {
				width = 256; height = 192;
            }
            else if (preferences.imageSize.value == "384x288")
            {
				width = 384; height = 288;
            }
            else if (preferences.imageSize.value == "448x336")
            {
				width = 448; height = 336;
            }
            else if (preferences.imageSize.value == "512x384")
            {
				width = 512; height = 384;
            }
            else if (preferences.imageSize.value == "576x432")
            {
				width = 576; height = 432;
            }
            else if (preferences.imageSize.value == "640x480")
            {
				width = 640; height = 480;
            }
            else
            {
				width = 319; height = 239;
		// This is not set for exactly 320x240 because of the 'image loads half way' problem that occurs
		// when the source image size is the exact dimension of your image size preference.
	    }
            
            print("W:"+width+" H:"+height);
            
            mainWindow.width = width;
            mainWindow.height = height+25;
            
            top.width = width;

            fadeImage.vOffset = 26;
            fadeImage.hOffset = 0;
            fadeImage.width  = cameraImage.width = width;
            fadeImage.height = cameraImage.height = height;

            imageTitle.vOffset = 17;
            imageTitle.hOffset = fadeImage.width - 25;
            
            imageTitleShadow.vOffset = imageTitle.vOffset + 1;
            imageTitleShadow.hOffset = imageTitle.hOffset + 1;
            
            pauseTitle.vOffset = imageTitle.vOffset;
            pauseTitle.hOffset = 55;

            pauseShadow.vOffset = pauseTitle.vOffset + 1;
            pauseShadow.hOffset = pauseTitle.hOffset + 1;

            nextImage.vOffset = 5;
            nextImage.hOffset = fadeImage.width - 20;
            
            resumeUpdates();
            updateNow();
        }

        updateSize();
        mainWindow.visible = true;
		nextIndex();